#ifndef _GRABBER_H
#define _GRABBER_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <curl/curl.h>

#ifndef XKCDSW_URL
#define XKCDSW_URL "http://echochamber.me/viewtopic.php?f=2&t=22741&start=%i"
#endif

#ifndef XKCDSW_ATTACH_BASE
#define XKCDSW_ATTACH_BASE "http://echochamber.me/"
#endif

#ifndef LINE_LENGTH
#define LINE_LENGTH 4096
#endif

#define URL_LENGTH 512
#define TITLETEXT_LENGTH 1024

#define FILEEXT_LENGTH 5

extern const char * const grabber_html_entities[][2];

struct grabber_buffer
{
	size_t length;
	char *data;
};

struct xkcdsw_item
{
	char url[URL_LENGTH];
	char titletext[TITLETEXT_LENGTH];
};

struct grabber_handle
{
	CURL *curl;
	struct grabber_buffer buffer;
};

struct file_buffer
{
	char ext[FILEEXT_LENGTH];
	size_t length;
	char *data;
};

void grabber_buffer_clean (struct grabber_buffer *buffer);

size_t fetch_callback (void *ptr, size_t size, size_t nmemb, void *data);

struct grabber_handle *grabber_init (void);
size_t grabber_fetch_xkcdsw (struct grabber_handle *handle, size_t max_items, struct xkcdsw_item *item_buffer, unsigned int page_start);
void grabber_cleanup (struct grabber_handle *handle);

char *htmlent_replace (const char *s);

unsigned int get_last_page (struct grabber_handle *handle);

int download_comic (struct grabber_handle *handle, struct file_buffer *buf, const struct xkcdsw_item *item);

#endif
